#!/bin/sh

# Useage: ./hisi.sh [-r]
#         -r : rmmod all modules
#    default : insmod all modules

insert_audio()
{
    insmod hidmac.ko
    insmod hi3521_sio.ko
    insmod hi3521_ai.ko
    insmod hi3521_ao.ko
    insmod hi3521_aenc.ko
    insmod hi3521_adec.ko
}

remove_audio()
{
    rmmod hi3521_adec
    rmmod hi3521_aenc
    rmmod hi3521_ao
    rmmod hi3521_ai
    rmmod hi3521_sio
    rmmod hidmac
}

insert_ko()
{
	sh ./pinmux_ahd_4_8.sh > /dev/null
	sh ./clkcfg_hi3521.sh > /dev/null

	#The ddr priority must be set before inserting all modules, otherwise vou will be low bandwidth(or flicker) when the machine is starting up.
	sh ./sysctl_hi3521.sh > /dev/null

	#192M
	insmod mmz.ko mmz=anonymous,0,0x8c000000,319M  anony=1 || report_error
 
	insmod hiuser.ko
	insmod hi3521_base.ko
	insmod hi3521_sys.ko
	insmod hi3521_tde.ko g_u32TdeTmpBufW=0 g_u32TdeTmpBufH=0
	insmod hi3521_dsu.ko
	insmod hi3521_venc.ko
	insmod hi3521_group.ko
	insmod hi3521_chnl.ko
	insmod hi3521_h264e.ko
	insmod hi3521_rc.ko
	insmod hi3521_jpege.ko
#	insmod hi3516_mpeg4e.ko
	insmod hi3521_viu.ko
	insmod hi3521_vou.ko
	insmod hi3521_vpss.ko
	insmod hi3521_ive.ko
	insmod hi3521_vda.ko
	insmod hi3521_region.ko
	insmod vcmp.ko
	insmod hifb.ko video="hifb:vram0_size:8100,vram1_size:1620,vram2_size:1620,vram3_size:32" softcursor="off" u32VcmpBufNum=2
	insmod hi3521_vdec.ko
	insmod hi3521_vfmw.ko
	insmod hi3521_hdmi.ko
	insmod jpeg.ko
	
	# AUDIO   ݵ ־ .
	insmod hi_dummy.ko
	insert_audio
}

remove_ko()
{
	remove_audio
	rmmod ssp
	rmmod gpioi2c
	rmmod hifb
	rmmod vcmp
	rmmod hi3521_region
	rmmod hi3521_ive
	rmmod hi3521_vda
	rmmod hi3521_vpss
	rmmod hi3521_vou
	rmmod hi3521_viu
	rmmod jpeg
	rmmod hi3521_hdmi.ko
	rmmod hi3521_vfmw.ko
	rmmod hi3521_vdec.ko   
	rmmod hi3521_jpege
	rmmod hi3521_rc
	rmmod hi3521_h264e
#	rmmod hi3526_mpeg4e
	rmmod hi3521_chnl
	rmmod hi3521_group
	rmmod hi3521_venc
	rmmod hi3521_dsu
	rmmod hi3521_tde
	rmmod hi3521_sys
	rmmod hi3521_base
	rmmod mmz
	rmmod hi_gpio
	rmmod hi_ir
	rmmod i2c.ko
	rmmod hiuser
}

# Main Text

if [ "$1" = "-r" ]; then
    remove_ko
else
    insert_ko
fi

# EOF
