#!/bin/sh

# Useage: ./hisi.sh [-r]
#         -r : rmmod all modules
#    default : insmod all modules

CHANNEL=`/sbin/boardid -s`

insert_audio()
{
    insmod hidmac.ko
    insmod hi3531_sio.ko
    insmod hi3531_ai.ko
    insmod hi3531_ao.ko
    insmod hi3531_aenc.ko
    insmod hi3531_adec.ko
}

remove_audio()
{
    rmmod hi3531_adec
    rmmod hi3531_aenc
    rmmod hi3531_ao
    rmmod hi3531_ai
    rmmod hi3531_sio
    rmmod hidmac
}

insert_ko()
{
    #########################################
    if [ "$CHANNEL" = "8" ]; then
        # 160M for AHD-8CH
        sh ./pinctrl_8_hi3531.sh > /dev/null
        sh ./clkcfg_hi3531.sh > /dev/null    
        insmod mmz.ko mmz=anonymous,0,0x8A000000,90M:jpeg,0,0x8FA00000,5M:ddr1,0,0xC0000000,255M anony=1
    else
        # 160M for AHD-16CH
        sh ./pinctrl_16_hi3531.sh > /dev/null
        sh ./clkcfg_hi3531.sh > /dev/null    
        insmod mmz.ko mmz=anonymous,0,0x8A000000,346M:jpeg,0,0x9FA00000,5M:ddr1,0,0xC0000000,511M anony=1
    fi
    #########################################

    insmod hiuser.ko
    insmod hi3531_base.ko
    insmod hi3531_sys.ko
    insmod hi3531_tde.ko g_pszTdeMmzName="mmzname" g_u32TdeTmpBufW=800 g_u32TdeTmpBufH=600
    insmod hi3531_dsu.ko
    insmod hi3531_venc.ko
    insmod hi3531_group.ko
    insmod hi3531_chnl.ko
    insmod hi3531_h264e.ko
    insmod hi3531_rc.ko
    insmod hi3531_jpege.ko
#   insmod hi3531_mpeg4e.ko
    insmod hi3531_viu.ko
    insmod hi3531_vou.ko
    insmod hi3531_vpss.ko
    insmod hi3531_region.ko
    insmod hi3531_ive.ko
    insmod hi3531_vda.ko
    insmod vcmp.ko

    insmod hifb.ko video="hifb:vram0_size:7200,vram1_size:7200,vram2_size:3240,vram3_size:3240,\
                vram4_size:7200,vram5_size:128,vram6_size:128" softcursor="off" u32VcmpBufNum=2\
                apszLayerMmzNames="mmzname0","mmzname1",,"graphics",,"mmzname0"

    insmod hi3531_vdec.ko
    insmod hi3531_vfmw.ko
    insmod hi3531_hdmi.ko
    insmod jpeg.ko

	# AUDIO   ݵ ־ .
	insmod hi_dummy.ko
    insert_audio

    #################################
    sh ./sysctl_hi3531.sh > /dev/null
    #################################
}

remove_ko()
{
    remove_audio

    rmmod hifb
    rmmod vcmp
    rmmod hi3531_hdmi.ko
    rmmod hi3531_vda.ko
    rmmod hi3531_ive.ko
    rmmod hi3531_region
    rmmod hi3531_vpss
    rmmod hi3531_vou
    rmmod hi3531_viu
    rmmod jpeg.ko
    rmmod hi3531_vfmw.ko
    rmmod hi3531_vdec.ko   
    rmmod hi3531_jpege
    rmmod hi3531_rc
    rmmod hi3531_h264e
#   rmmod hi3531_mpeg4e
    rmmod hi3531_chnl
    rmmod hi3531_group
    rmmod hi3531_venc
    rmmod hi3531_dsu
    rmmod hi3531_tde
    rmmod hi3531_sys
    rmmod hi3531_base
    rmmod mmz
    rmmod hiuser
}

# Main Text

if [ "$1" = "-r" ]; then
    remove_ko
else
    insert_ko
fi

# EOF
